<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RequiredField ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RequiredField extends AbstractStructArrayBase
{
    /**
     * The Field
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RequiredField[]
     */
    public $Field;
    /**
     * Constructor method for ArrayOfJP_RequiredField
     * @uses ArrayOfJP_RequiredField::setField()
     * @param \StructType\JP_RequiredField[] $field
     */
    public function __construct(array $field = array())
    {
        $this
            ->setField($field);
    }
    /**
     * Get Field value
     * @return \StructType\JP_RequiredField[]|null
     */
    public function getField()
    {
        return $this->Field;
    }
    /**
     * Set Field value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RequiredField[] $field
     * @return \ArrayType\ArrayOfJP_RequiredField
     */
    public function setField(array $field = array())
    {
        foreach ($field as $arrayOfJP_RequiredFieldFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RequiredFieldFieldItem instanceof \StructType\JP_RequiredField) {
                throw new \InvalidArgumentException(sprintf('The Field property can only contain items of \StructType\JP_RequiredField, "%s" given', is_object($arrayOfJP_RequiredFieldFieldItem) ? get_class($arrayOfJP_RequiredFieldFieldItem) : gettype($arrayOfJP_RequiredFieldFieldItem)), __LINE__);
            }
        }
        $this->Field = $field;
        return $this;
    }
    /**
     * Add item to Field value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RequiredField $item
     * @return \ArrayType\ArrayOfJP_RequiredField
     */
    public function addToField(\StructType\JP_RequiredField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RequiredField) {
            throw new \InvalidArgumentException(sprintf('The Field property can only contain items of \StructType\JP_RequiredField, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Field[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RequiredField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RequiredField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RequiredField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RequiredField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RequiredField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Field
     */
    public function getAttributeName()
    {
        return 'Field';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RequiredField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
